#include "init.h"

extension ext;

bool isInString(char *string, const char *search)
{
	int pos=0;
	int maxpos=strlen(search)-1;
	int len=strlen(string);	
	char *other;
	for (int i=0; i<len; i++) 
	{
		if ((i==0) || ((i>1) && string[i-1]=='\n')) 
		{							// New Extension Begins Here!
			other=&string[i];			
			pos=0;													// Begin New Search
			while (string[i]!='\n') 
			{														// Search Whole Extension-String
				if (string[i]==search[pos]) pos++;					// Next Position
				if ((pos>maxpos) && string[i+1]=='\n') return true; // We Have A Winner!
				i++;
			}			
		}
	}	
	return false;													// Sorry, Not Found!
}

int extInit()
{
	char *extensions;
	extensions=strdup((char *) glGetString(GL_EXTENSIONS));			// Fetch Extension String
	int len=strlen(extensions);
	for (int i=0; i<len; i++)										// Separate It By Newline Instead Of Blank
		if (extensions[i]==' ') extensions[i]='\n';

	if(isInString(extensions,"GL_ARB_texture_compression"))ext.ARB_texture_compression=1;
	if(isInString(extensions,"GL_ARB_texture_cube_map"))ext.ARB_texture_cube_map=1;
	if(isInString(extensions,"GL_EXT_bgra"))ext.EXT_bgra=1;
	if(isInString(extensions,"GL_EXT_texture_cube_map"))ext.ARB_texture_cube_map=1;
	if(isInString(extensions,"GL_EXT_texture_edge_clamp"))ext.EXT_texture_edge_clamp=1;
	if(isInString(extensions,"GL_SGI_texture_edge_clamp"))ext.EXT_texture_edge_clamp=1;
	if(isInString(extensions,"GL_EXT_texture_filter_anisotropic"))ext.EXT_texture_filter_anisotropic=1;
	if(isInString(extensions,"GL_SGIS_generate_mipmap"))ext.SGIS_generate_mipmap=1;

	glGetIntegerv( GL_MAX_TEXTURE_SIZE, &ext.max.max_texture_size);
	if(ext.ARB_texture_cube_map)
		glGetIntegerv( GL_MAX_CUBE_MAP_TEXTURE_SIZE_ARB, &ext.max.max_cube_map_texture_size);
	else
		ext.max.max_cube_map_texture_size=1;
	if(ext.EXT_texture_filter_anisotropic)
		glGetIntegerv( GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT, &ext.max.max_texture_max_anisotropy);
	else
		ext.max.max_texture_max_anisotropy=1;

	free(extensions);
	return 1;
}