/* These extensions are supported:
GL_ARB_texture_compression		// Not all
GL_ARB_texture_cube_map

GL_EXT_bgra
GL_EXT_texture_edge_clamp
GL_EXT_texture_filter_anisotropic

GL_SGIS_generate_mipmap
GL_SGIS_texture_edge_clamp

*/

#ifndef __EXTGL_H_
#define __EXTGL_H_

#ifdef __cplusplus
extern "C" {
#endif

#ifndef APIENTRY
#define WIN32_LEAN_AND_MEAN 1
#include <windows.h>
#endif

#define GL_CLAMP_TO_EDGE							0x812F

/* GL_ARB_texture_compression  - Not all */ 
#ifndef GL_ARB_texture_compression
#define GL_ARB_texture_compression 1

#define GL_COMPRESSED_ALPHA_ARB               0x84E9
#define GL_COMPRESSED_LUMINANCE_ARB           0x84EA
#define GL_COMPRESSED_LUMINANCE_ALPHA_ARB     0x84EB
#define GL_COMPRESSED_INTENSITY_ARB           0x84EC
#define GL_COMPRESSED_RGB_ARB                 0x84ED
#define GL_COMPRESSED_RGBA_ARB                0x84EE
#define GL_TEXTURE_COMPRESSION_HINT_ARB       0x84EF
#define GL_TEXTURE_COMPRESSED_IMAGE_SIZE_ARB  0x86A0
#define GL_TEXTURE_COMPRESSED_ARB             0x86A1
#define GL_NUM_COMPRESSED_TEXTURE_FORMATS_ARB 0x86A2
#define GL_COMPRESSED_TEXTURE_FORMATS_ARB     0x86A3
#endif /* GL_ARB_texture_compression */

/* GL_ARB_texture_cube_map */
#ifndef GL_ARB_texture_cube_map
#define GL_ARB_texture_cube_map 1

#define GL_NORMAL_MAP_ARB							0x8511
#define GL_REFLECTION_MAP_ARB						0x8512
#define GL_TEXTURE_CUBE_MAP_ARB						0x8513
#define GL_TEXTURE_BINDING_CUBE_MAP_ARB				0x8514
#define GL_TEXTURE_CUBE_MAP_POSITIVE_X_ARB			0x8515
#define GL_TEXTURE_CUBE_MAP_NEGATIVE_X_ARB			0x8516
#define GL_TEXTURE_CUBE_MAP_POSITIVE_Y_ARB			0x8517
#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_ARB			0x8518
#define GL_TEXTURE_CUBE_MAP_POSITIVE_Z_ARB			0x8519
#define GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_ARB			0x851A
#define GL_PROXY_TEXTURE_CUBE_MAP_ARB				0x851B
#define GL_MAX_CUBE_MAP_TEXTURE_SIZE_ARB			0x851C
#endif /* GL_ARB_texture_cube_map */

/* GL_EXT_texture_filter_anisotropic */
#ifndef GL_EXT_texture_filter_anisotropic
#define GL_EXT_texture_filter_anisotropic    1

#define GL_TEXTURE_MAX_ANISOTROPY_EXT        0x84FE
#define GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT    0x84FF
#endif /* GL_EXT_texture_filter_anisotropic */

/* GL_SGIS_generate_mipmap */
#ifndef GL_SGIS_generate_mipmap
#define GL_SGIS_generate_mipmap              1

#define GL_GENERATE_MIPMAP_SGIS              0x8191
#define GL_GENERATE_MIPMAP_HINT_SGIS         0x8192
#endif /* GL_SGIS_generate_mipmap */


#ifdef __cplusplus
}
#endif

int extInit();

struct extension
{
	int ARB_texture_compression;
	int ARB_texture_cube_map;
	int EXT_bgra;
	int EXT_texture_edge_clamp;
	int EXT_texture_filter_anisotropic;
	int SGIS_generate_mipmap;
	struct maximum
	{
		int	max_texture_size;
		int max_cube_map_texture_size;
		int max_texture_max_anisotropy;
	}max;
};

extern extension ext;
#endif // __EXTGL_H_