#ifndef _TEXTURE_H
#define _TEXTURE_H

#include "init.h"
#include "jpeglibm.h"
/*
struct IMAGE
{
	int planes;					// pocet rovin
	int sizeX;					// sirka obrazka
	int sizeY;					// vyska obrazka
	unsigned char *data;		// smernik na data
	char isBGR;					// nastavene na 1, ak nacitane data su bgr
	IMAGE(){ planes=0; sizeX=0; sizeY=0; data=NULL; isBGR=0; }
};*/

class texture  
{
	IMAGE im;
public:
	void setCubeForCopyToTexture(int x, int y, int repeat=0, int filter=1);
	void setForCopyToTexture( int x, int y, int repeat=0, int filter=3);
	IMAGE invShift(const IMAGE &in);
	IMAGE shift(const IMAGE &in);
	IMAGE resizeToHalfXY(const IMAGE &in);
	IMAGE resizeToHalfY( const IMAGE &in);
	IMAGE resizeToHalfX(const IMAGE &in);
	char isPow2(int x){	for( int i=0; x; x>>=1) if(x&1)i++; return (i==1);}
	IMAGE resize( const IMAGE &in, int newx, int newy);
	IMAGE LoadBMP1bit(FILE *f, IMAGE &i, BITMAPFILEHEADER &fileheader, BITMAPINFOHEADER &infoheader);
	IMAGE LoadBMP4bit(FILE *f, IMAGE &i, BITMAPFILEHEADER &fileheader, BITMAPINFOHEADER &infoheader);
	IMAGE LoadBMP8bit( FILE* f, IMAGE &i, BITMAPFILEHEADER &fileheader, BITMAPINFOHEADER &infoheader);
	void FlipMirror( IMAGE &i);
	int loadCube( char* directory, char* extension, int filter=3, int compression=0 );
	void Flip( IMAGE &i);
	void glBindTexture2D(){ glBindTexture( GL_TEXTURE_2D, id); }
	void glBindTextureCube(){ glBindTexture( GL_TEXTURE_CUBE_MAP_ARB, id); }
	void BGRtoRGB( IMAGE &i);
	IMAGE LoadJPG( char* filename );
	IMAGE LoadTGA( char* filename );
	IMAGE LoadBMP( char* filename );
	unsigned int id;
	char *name;
	char *extens;		// iba pre cube map
	int load( char* filename, int repeat=1, int filter=3, int compression=0 );
	int reload( int repeat, int filter){ return load( name, repeat, filter); }
	int reloadCube( int filter){ return loadCube( name, extens, filter); }

	texture();
	virtual ~texture();
};

#endif // _TEXTURE_H